summaryrefslogtreecommitdiff
path: root/tests/other-fs-tmpdir
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2006-10-25 00:01:33 +0200
committerJim Meyering <jim@meyering.net>2006-10-25 00:01:33 +0200
commit5e42576c017905627e209acc20bf6e6abd1db6ef (patch)
treedec84f1b293d51189d9ab440710d8ca16bc91c4c /tests/other-fs-tmpdir
parentba6b1acefd8c9d9a4c506806d68e891879706a2c (diff)
downloadcoreutils-5e42576c017905627e209acc20bf6e6abd1db6ef.tar.xz
new feature: rm accepts new option: --one-file-system
Suggested by Steve McIntyre in <http://bugs.debian.org/392925>. * src/remove.h (struct rm_options) [one_file_system]: New member. * src/rm.c (rm_option_init): Initialize it. (usage): Document the option. * src/mv.c (rm_option_init): Likewise. * src/remove.c (remove_dir): With --one-file-system and --recursive, for each directory command line argument, do not affect a file system different from that of the starting directory. And give a diagnostic. * src/rm.c (ONE_FILE_SYSTEM): New enum. (main): Handle new option. * tests/rm/one-file-system: Test the above. * tests/rm/Makefile.am (TESTS): Add one-file-system. * tests/Makefile.am (check-root): Add the rm/one-file-system test to the list. (EXTRA_DIST): Add other-fs-tmpdir. * tests/mv/setup: Removed. Renamed to... * tests/other-fs-tmpdir: ...this new file. * tests/mv/Makefile.am (EXTRA_DIST): Remove setup. * tests/mv/acl: Reflect renaming: use ../other-fs-tmpdir. * tests/mv/backup-is-src: Likewise. * tests/mv/hard-link-1: Likewise. * tests/mv/leak-fd: Likewise. * tests/mv/mv-special-1: Likewise. * tests/mv/part-fail: Likewise. * tests/mv/part-hardlink: Likewise. * tests/mv/part-rename: Likewise. * tests/mv/part-symlink: Likewise. * tests/mv/partition-perm: Likewise. * tests/mv/to-symlink: Likewise. * tests/mv/into-self-2: Likewise. [doc/ChangeLog] * coreutils.texi (rm invocation): Describe --one-file-system.
Diffstat (limited to 'tests/other-fs-tmpdir')
-rwxr-xr-xtests/other-fs-tmpdir61
1 files changed, 61 insertions, 0 deletions
diff --git a/tests/other-fs-tmpdir b/tests/other-fs-tmpdir
new file mode 100755
index 000000000..0886437aa
--- /dev/null
+++ b/tests/other-fs-tmpdir
@@ -0,0 +1,61 @@
+#! /bin/sh
+
+# Use stat to find a writable directory on a file system different from that
+# of the current directory. If one is found, create a temporary directory
+# inside it.
+
+# Copyright (C) 1998, 1999, 2001, 2002, 2005 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+test "${CANDIDATE_TMP_DIRS+set}" = set \
+ || CANDIDATE_TMP_DIRS="$TMPDIR /tmp /var/tmp /usr/tmp $HOME"
+
+other_partition_tmpdir=
+
+dot_mount_point=`stat -c %d .`
+for d in $CANDIDATE_TMP_DIRS; do
+
+ # Skip nonexistent directories.
+ test -d $d || continue
+
+ d_mount_point=`stat -L -c %d $d`
+
+ # Same partition? Skip it.
+ test x$d_mount_point = x$dot_mount_point && continue
+
+ # See if we can create a directory in it.
+ if mkdir "$d/tmp$$" > /dev/null 2>&1; then
+ other_partition_tmpdir="$d/tmp$$"
+ break
+ fi
+
+done
+
+if test -z "$other_partition_tmpdir"; then
+ cat <<EOF 1>&2
+**************************************
+This test requires a writable directory on a different
+disk partition, and I couldn't find one. I tried these:
+ $CANDIDATE_TMP_DIRS
+Set your environment variable CANDIDATE_TMP_DIRS to make
+this test use a different list.
+**************************************
+EOF
+ #'
+fi
+
+test "$VERBOSE" = yes && set -x